#ifndef __Permute_h__
#define __Permute_h__

#include "Options.h"
#include "SparseMatrix.h"
#include "Remembrance.h"

struct ordertreerange {
    long PiLo, PiHi;
    
    long LeftCount, CutCount, RightCount;
    long LeftStart, CutStart, RightStart;
    long LeftChild, CutChild, RightChild;
    int WasTagged;
    int Meta; /* 0 block, 1 cut, 2 multiple cuts */
};

struct ordertree {
    int *NetAssign;
    long *NetToRange;
    long *Pi;
    
    struct ordertreerange *Ranges;
    long NrRanges, NrNets;
    
    struct ordertreerange **TagList;
    long NrTags;
};

int CreateOrderTree(struct ordertree *Tree, const long NrNets, const long Lo, const long Hi, const long *Net);
int DestroyOrderTree(struct ordertree *Tree);
int OrderTreeSplit(struct ordertree *Tree, const long Lo, const long Mid, const long Hi, const long *Net, const struct opts *pOptions, struct remembrance * const m );

#endif

